// TODO:
// Start with external BUTTON
// Anti-Antonin

//-------------------
var gameDuration   = 90;
var h              = window.innerHeight;
var w              = window.innerWidth;
var leftW          = h*1.25;
var margin         = h/15;
var waitForStart   = true;        // waiting to push start
var cheat          = false;
var receiptPrinted = true;
var highScore      = 0;
var newHighScore   = false;
var lastScannedItem = -1;

//------------------------------------------------------------------------------ init
function init(){
  console.log(items);
  layout();
  newGame();
  bgndInterval = setInterval(bgndLoop, 100);
}
//------------------------------------------------------------------------------ bgndLoop triggers announcements // toggles texts
var loopCount = 0;
var gameTime  = 0;
function bgndLoop(){
  loopCount++;
  if (gameRunning){gameTime=loopCount;}
  if (loopCount-gameTime>600){
    announcement();
    gameTime=loopCount;
  }
  switch ((loopCount/25)%3){
    case 0:
      document.getElementById('start').innerHTML=" POUSSEZ LE BUTTON <br> POUR CONSOMMER ";
    break;
    case 1:
      document.getElementById('start').innerHTML=" SCANNEZ L'ARTICLE <br> DANS LA PHOTO ";
    break;
    case 2:
      document.getElementById('start').innerHTML=" VOUS AVEZ <br> "+gameDuration+" SECONDES! ";
    break;
  }


}
//------------------------------------------------------------------------------ fullscreen
function toggleFullScreen() {
  if (!document.fullscreenElement) {
      document.documentElement.requestFullscreen();
  } else {
    if (document.exitFullscreen) {
      document.exitFullscreen();
    }
  }
  layout();
}

//------------------------------------------------------------------------------ new game
function newGame(){
  loopCount=0;
  waitForStart = true;
  receiptPrinted = false;
  document.getElementById('startButtonContainer').style ='display:block; position:absolute; top:'+(h*.3)+'px;';
  document.getElementById('start').style ='display:inline-block;font-size: '+(w/18)+'px;';
  bellSound();
}
//------------------------------------------------------------------------------ start game
function startGame(){
  startSound();
  waitForStart = false;
  lastScannedItem = -1;
  scanTime = maxTimer;
  document.documentElement.requestFullscreen();
  document.getElementById('start').style         ='display:none;';
  document.getElementById('highScoreScreen').style.opacity=0;

  //if (cheat){maxTimer=gameDuration+15;}else{maxTimer=gameDuration;}                                 // extra time for cheaters :)
  timer=maxTimer;
  receiptString       = intialReceiptString;
  totalValue          = 0;
  addToReceipt('',0);
  layout();
  newRandomItem();
  startTimer();
  startAtmo();
}
//------------------------------------------------------------------------------ resize
function resize(){
  h = window.innerHeight;
  w = window.innerWidth;
  layout();
}
//------------------------------------------------------------------------------ layout
function layout(){
  console.log('w:'+w+' h:'+h);
  var receiptWidth=(w-leftW-margin);
  document.getElementById('receipt').style ='\
    width:'+receiptWidth+'px; \
    font-size:'+(receiptWidth/20)+'px;\
    padding:'+(margin/2)+'px;';

  document.getElementById('itemTextContainer').style ='position:absolute; top:'+margin+'px; left:0px; width:'+leftW+'px;';
  document.getElementById('picture').style       ='width:'+leftW+margin+'px; ';
  //document.getElementById('itemText').style      ='position:absolute; top:'+margin+'px; left:0px; width:'+leftW+'px;';
  document.getElementById('itemPrice').style     ='position:absolute; bottom:17vh; right:45vw;height:12vh';
}
//------------------------------------------------------------------------------ end screen layout
function endScreenLayout(){
  document.getElementById('receipt').style='\
    width:'+w+'px;\
    font-size: '+(w/23)+'px;\
    padding:'+(margin*2)+'px;';
    setTimeout(newGame,5000);
}

//------------------------------------------------------------------------------ new random item
var randomItem=0; // a random item that has to be scanned next
var itemPrice;
var discountTimer =0;

function newRandomItem(){
  discountTimer=timer;
  // find new random number that is different from last random number
  if (!cheat || Math.random()<.15){  // no cheat, find a random item
    randomItem += Math.floor(Math.random()*(items-2)+1);
    randomItem = randomItem%items;
  }else{        // cheat : find 3 random items and take the most expensive
    var newRandomItem1 = Math.floor(Math.random()*(items-2)+1) + randomItem;
        newRandomItem1 = newRandomItem1%items;
    var newRandomItem2 = Math.floor(Math.random()*(items-2)+1) + randomItem;
        newRandomItem2 = newRandomItem2%items;
    var newRandomItem3 = Math.floor(Math.random()*(items-2)+1) + randomItem;
        newRandomItem3 = newRandomItem3%items;
    if (item[newRandomItem1].price > item[newRandomItem2].price){randomItem=newRandomItem1;}else{randomItem=newRandomItem2;}
    if (item[newRandomItem3].price > item[randomItem].price){randomItem=newRandomItem3;}
  }

  itemPrice  = item[randomItem].price;
  document.getElementById('itemText').innerHTML='&nbsp;Scannez:&nbsp;<br>&nbsp;<b>'+item[randomItem].name+'</b>&nbsp;';
  document.getElementById('picture').innerHTML='<img id="itemPic" src="items/'+item[randomItem].img+'">';

  var itemPic = document.getElementById("itemPic");
  itemPic.style='position:absolute;top:0px;left:0px; height:'+h+'px;';

}


//------------------------------------------------------------------------------ timer

var maxTimer    = 90;
var timer       = maxTimer;  // timer in s
var interval    = 50;        // loop interval in ms
var gameRunning = false;
function startTimer(milliseconds){//............................................ start timer loop
  timerInterval = setInterval(timerLoop, interval);
  gameRunning   = true;
}

function timerLoop(){//......................................................... timer loop
  timer -= (interval/1000);                     // reduce timer

  if (discountTimer-timer>3){                   // get discounts
    discountTimer=timer;
    discount();
    discountSound();
  }

  if (timer<0){                                 // stop if time is over : game over
    gameRunning = false;
    clearInterval(timerInterval);               // stop this loop
    stopAtmo();
    cashOutSound();
    newHighScore = false;
    if (totalValue>highScore){
      newHighScore=true;  // new highscore!!!
      highScore = totalValue;
      if (newHighScore){
        document.getElementById('highScoreScreen').style.opacity=1;
        setTimeout(highscoreSound,500);
      }else{
        document.getElementById('highScoreScreen').style.opacity=0;
      }
    }
    if (!receiptPrinted){ // print receipt on POS printer
      document.getElementById('price').innerHTML='<b>TOTAL:</b><br>'+Intl.NumberFormat('de-DE', { minimumFractionDigits: 2, maximumFractionDigits: 2 }).format(totalValue)+'€';
      let currentDate  = new Date();
      let cDay         = currentDate.getDate();
      let cMonth       = currentDate.getMonth() + 1;
      let cYear        = currentDate.getFullYear();
      document.getElementById('address').innerHTML=cDay + "/" + cMonth + "/" + cYear +"<br><br>HYPERMARCHENIAROF<br>LES 8 PILLARDS - 15<br>RUE DES FRAIRES CUBEDDU<br>13014 MARSEILLE";
      document.getElementById('vat').innerHTML="CE SCORE INCLUT<br>20% DE TVA<br><br>HIGHSCORE DU JOUR<br><b>"+Intl.NumberFormat('de-DE', { minimumFractionDigits: 2, maximumFractionDigits: 2 }).format(highScore)+"€</b><br><br>MERCI DE VOTRE VISITE<br>ET A BIENTOT";
      if (newHighScore){
        document.getElementById('hiscore').style.opacity=1;
      }else{
        document.getElementById('hiscore').style.opacity=0;
      }
      window.print();
      receiptPrinted=true;
    }
    setTimeout(endScreenLayout,500);            // layout end screen after short delay
    document.getElementById('timerBar').style='display:none;'; // hide timer bar
    document.getElementById('timer').style='display:none;'; // hide timer bar
    return;                                     // don't execute rest of this loop
  }
  var bottom = margin;                              // size and position of bar
  var width  = leftW-margin*2-4;
  var height = h/20;
                                               // draw timer bar
  var timerW=63; // width of seconds on screen
  document.getElementById('timerBgnd').style='display:block; position:absolute; left:'+(margin+timerW)+'px; width:'+(width-timerW)+'px; height:'+height+'px; bottom:'+bottom+'px;background:red;border:4px solid red;box-shadow:15px 15px 13px rgba(0,0,0,.2);';
  document.getElementById('timerBar').style ='display:block; position:absolute; left:'+(margin+timerW)+'px; width:'+((width-timerW)*(timer/maxTimer))+'px; height:'+height+'px; bottom:'+bottom+'px;background:yellow;border:4px solid red;';
  document.getElementById('timer').style ='display:block; position:absolute; left:'+margin+'px; bottom:'+(bottom)+'px;color:yellow;background:red; height:'+height+';font-size:'+(height)+'px;font-weight:bold;padding-left:5px;padding-right:5px;box-shadow:15px 15px 13px rgba(0,0,0,.2);';
  document.getElementById('timer').innerHTML = Math.floor(timer+1);
}

//------------------------------------------------------------------------------ discount / promo!
function discount(){
  var randomDiscount=Math.floor(Math.random()*3+1);
  switch (Math.floor(Math.random()*3)){
    case 0:
    addToReceipt("*** PROMO ***    ", -randomDiscount);
    break;
    case 1:
    addToReceipt("*** SOLDE ***    ", -randomDiscount);
    break;
    default:
    addToReceipt("*** REDUC ***    ", -randomDiscount);
    break;
  }
  if(randomDiscount==1){itemPrice = itemPrice*.5;}else{itemPrice = itemPrice*.9;}
  document.getElementById('itemPrice').innerHTML=Intl.NumberFormat('de-DE', { minimumFractionDigits: 2, maximumFractionDigits: 2 }).format(itemPrice)+"€";
  document.getElementById('picture').innerHTML+='<img src="pics/discount'+randomDiscount+'.png" style="filter:saturate(3);position:fixed;left:'+Math.random()*(leftW-300)+'px;top:'+Math.random()*(h-300)+'px; width:'+(Math.random()*(h/5)+(h/4))+'px; transform:rotate('+(Math.random()*60-40)+'deg);filter: drop-shadow(5px 5px 3px rgba(0,0,0,.4));">';

}

//------------------------------------------------------------------------------ wrong item was scanned
function badScan(){
  //timer-=3;
  discount();
  wrongSound();
}

//------------------------------------------------------------------------------ good scan: the right item was scanned!
function goodScan(){
  timer = Math.min(timer,maxTimer);
  addToReceipt(item[randomItem].name, itemPrice);
  rightSound();
  newRandomItem();
  document.getElementById('itemPrice').innerHTML=Intl.NumberFormat('de-DE', { minimumFractionDigits: 2, maximumFractionDigits: 2 }).format(itemPrice)+"€";
}

//------------------------------------------------------------------------------ show receipt
var intialReceiptString = '<br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><b>************************************<br><br>        BIENVENUE AU BONPRIX!        <br><br>************************************</b><br><br>';
var receiptString       = intialReceiptString;
var totalValue          = 0;

function addToReceipt(nameToAdd, priceToAdd){
    var asciiPrice     = '-10%';
    if(priceToAdd      == -1){
      var asciiPrice     = '-50%';
    }
    if(priceToAdd      == 0){
      var asciiPrice     = '';
    }
    if(priceToAdd>0){
      asciiPrice     = Intl.NumberFormat('de-DE', { minimumFractionDigits: 2, maximumFractionDigits: 2 }).format(priceToAdd).padStart(7, ' ')+'€';
      totalValue    += priceToAdd;
    }
    receiptString += nameToAdd+' '+asciiPrice+' <br>'
    var asciiTotal     = Intl.NumberFormat('de-DE', { minimumFractionDigits: 2, maximumFractionDigits: 2 }).format(totalValue).padStart(7, ' ');
    document.getElementById('receipt').innerHTML = receiptString+'<b>------------------------------------<br>TOTAL '+asciiTotal+'€ </b>';
}

//------------------------------------------------------------------------------ read keyboard & barcode scanner
var barcodeScan='';                                                           // string of scanned barcode

document.addEventListener('keydown', (event) => {                             // add keyboard listener (USB scanner is recognized as keyboard)
  document.documentElement.requestFullscreen();
  var test=false;
  const keyName = event.key;
  if (keyName=='F1'){barcodeScan='StartGame'; test=true;}
  if (keyName=='F2'){goodScan();}
                                               // incoming character(s)
  if(keyName=='Enter' || test){                         //............................ full barcode is scanned: check string
    console.log('Scanned: '+barcodeScan);

    if (barcodeScan=='StartGame'){              // start game via keybd/LEONARDO?
      cheat = false;
      barcodeScan='';
      if(waitForStart){startGame();}else if(gameRunning){badScan();}
      return;
    }
    if (barcodeScan=='StartCheat'){
      cheat = true;
      barcodeScan='';
      if(waitForStart){startGame();}else if(gameRunning){badScan();}
      return;
    }
    var scannedItem = codeToItem(barcodeScan);  // check item# for this scan

    document.getElementById('debug').innerHTML="last:"+lastScannedItem+" scanned:"+scannedItem+" t:"+Math.floor(scanTime-timer);
    if (lastScannedItem == scannedItem && Math.floor(scanTime-timer)<2){ // if barcode is read twice: return
      barcodeScan='';
      return;
    }
    document.getElementById('debug').innerHTML+=" ...OK";
    scanTime=timer;

    lastScannedItem = scannedItem;
    barcodeScan='';                             // reset barcodeScan string
    if (scannedItem == randomItem){
        if(gameRunning){goodScan();}            // success! the right item was scanned

    }else{
        if(gameRunning){badScan();}             // böööp! the wrong item was scanned

    }
  }else if (keyName.length==1){                 //............................ add character to barcodeScan string
    barcodeScan+=keyName;
  }

}, false);

//------------------------------------------------------------------------------ check which item# is related to this barcode
function codeToItem(code){
  var returnValue = -1;
  for (var i=0;i<items;i++){
    if (item[i].barcode==code){returnValue=i;}
  }
  return returnValue;                                                         // return item# or -1 for an error
}
